<?php
require_once (APP_PATH . "/application/library/PHPMailer-master/PHPMailerAutoload.php");

class ForwardModel extends Publicapi
{

	/**
	 * 初始化
	 *
	 * @return void
	 *
	 */
	public function init()
	{
		parent::init();
	}

	/**
	 * 文件路径
	 *
	 * @return void
	 *
	 */
	public function filerouteAction($id)
	{
		$arrNotifyType = array(
			'128' => 'APP',
			'64' => '短信',
			'32' => '语音',
			'16' => '邮件',
			'8' => '微信'
		);
		
		// 查找报警记录
		$sql = "SELECT * FROM alert_logs WHERE `ID`='$id' AND `is_confirmed`='0'";
		$arrAlertLogs = $this->db_getAll($sql);
		if (empty($arrAlertLogs)) {
			$this->setLog('报警记录不存在');
			return false;
		}
		
		// 查找接收人
		$sql = "SELECT * FROM users WHERE `m_alert_l` LIKE '%[" . $arrAlertLogs[0]['alert_level'] . "]%'";
		$arrUsers = $this->db_getAll($sql);
		if (empty($arrUsers)) {
			$this->setLog('接收人不存在');
			return false;
		}
		
		// 获取设置
		$sql = "SELECT * FROM parameters";
		$settings_info = $this->db_getAll($sql);
		foreach ($settings_info as $key => $value) {
			$info[$value['pname']] = $value['pval'];
		}
		$this->_data['settings_info'] = $info;
		
		foreach ($arrUsers as $key => $value) {
			// 检查权限
			if (! empty($value['m_group'])) {
				$bool = false;
				$arrM_group = explode(',', $value['m_group']);
				foreach ($arrM_group as $k => $val) {
					$sql = "SELECT `equipments` FROM groups_privileges WHERE `ID`='$val'";
					$arrGroupsPrivileges = $this->db_getAll($sql);
					if (empty($arrGroupsPrivileges)) {
						continue;
					}
					
					// 查找eq_sn、eq_no
					$arrEquips = explode(',', $arrGroupsPrivileges[0]['equipments']);
					foreach ($arrEquips as $i => $j) {
						$sql = "SELECT `ID` FROM equipments WHERE `ID`='$j' AND `eq_sn`='" . $arrAlertLogs[0]['eq_sn'] . "' AND `eq_no`='" . $arrAlertLogs[0]['eq_no'] . "'";
						$arrEquipments = $this->db_getAll($sql);
						if (! empty($arrEquipments)) {
							$bool = true;
							break 2;
						}
					}
				}
				
				if (! $bool) {
					$this->setLog('接收人无权限');
					continue;
				}
			}
			
			// 获取告警模板
			$sql = "SELECT * FROM alert_templates WHERE `ID`='" . $value['m_alert_t'] . "'";
			$arrAlertTemplates = $this->db_getAll($sql);
			if (empty($arrAlertTemplates)) {
				continue;
			}
			
			foreach ($arrNotifyType as $k => $val) {
				if ($arrAlertTemplates[0]['notify_mode'] & $k) {
					// 获取内容
					switch ($k) {
						case '128':
							// APP
							$content = $this->contentProcessing($arrAlertTemplates[0]['tpl_app'], $arrAlertLogs);
							$this->app($content);
							break;
						case '64':
							// 短信
							$content = $this->contentProcessing($arrAlertTemplates[0]['tpl_msg'], $arrAlertLogs);
							$this->sms($content, $value['phone']);
							break;
						case '32':
							// 语音
							$content = $this->contentProcessing($arrAlertTemplates[0]['tpl_phone'], $arrAlertLogs);
							$this->phone($content, $value['phone']);
							break;
						case '16':
							// 邮件
							$content = $this->contentProcessing($arrAlertTemplates[0]['tpl_mail'], $arrAlertLogs);
							$this->smtp($content, $value['mail']);
							break;
						case '8':
							// 微信
							$content = $this->contentProcessing($arrAlertTemplates[0]['tpl_wx'], $arrAlertLogs);
							$this->wx($content, $value['wxopenid']);
							break;
						default:
					}
				}
			}
		}
	}

	/**
	 * 发送APP消息
	 */
	public function app($content)
	{
		$this->setLog('APP报警:' . $content);
	}

	/**
	 * 发送短信
	 */
	public function sms($content, $phone)
	{
		$this->setLog('短信报警');
		
		// 获取系统参数
		$info = $this->_data['settings_info'];
		
		// 设备类型
		$equipments_type = isset($info['equipments_type']) ? $info['equipments_type'] : 'ptw72';
		
		// 区分PTW72 GPRS MODEM 和 OM-B4 综合报警器
		switch ($equipments_type) {
			case 'ptw72':
				$this->smsEquipment_1($phone, $content);
				break;
			case 'omb4_0':
			case 'omb4_1':
				$this->smsEquipment_2($phone, $content);
				break;
			case 'ums':
				$this->smsUMS($phone, $content);
				break;
			case 'jcwkj':
				$this->smsJCWKJ($phone, $content);
				break;
			default:
		}
	}

	/**
	 * 拨打电话
	 */
	public function phone($content, $phone)
	{
		$this->setLog('电话报警');
		
		// 获取系统参数
		$info = $this->_data['settings_info'];
		
		// 设备类型
		$equipments_type = isset($info['equipments_type']) ? $info['equipments_type'] : '';
		
		// 区分PTW72 GPRS MODEM 和 OM-B4 综合报警器
		switch ($equipments_type) {
			case 'omb4_0':
			case 'omb4_1':
				$this->tellEquipment_2($phone, $content);
				break;
			default:
		}
	}

	/**
	 * 发送邮件
	 */
	public function smtp($content, $mail)
	{
		$this->setLog('邮件报警');
		
		// 获取系统参数
		$info = $this->_data['settings_info'];
		
		// smtp ip
		$smtp_ip = isset($info['smtp_ip']) ? $info['smtp_ip'] : '';
		// 端口
		$smtp_port = isset($info['smtp_port']) ? $info['smtp_port'] : '';
		// 用户名
		$smtp_username = isset($info['smtp_username']) ? $info['smtp_username'] : '';
		// 密码
		$smtp_password = isset($info['smtp_password']) ? $info['smtp_password'] : '';
		
		$this->send_mail($mail, $smtp_username, $smtp_password, $smtp_ip, $smtp_port, $content);
	}

	/**
	 * 微信发送模板消息
	 */
	public function wx($content, $wxopenid)
	{
		$this->setLog("微信报警:" . date('Y-m-d H:i:s'));
		
		error_reporting(E_ALL ^ E_NOTICE ^ E_WARNING);
		
		$keyName = "PARAMETERS";
		$arrParameters = $this->_memcache->get($keyName);
		
		if ($arrParameters === false) {
			// 设置参数设置
			$arrParameters = $this->memcacheParameters();
		}
		
		$wxtemplateid = isset($arrParameters['wx_TplID']) ? $arrParameters['wx_TplID'] : '';
		
		$keyName = "ACCESS_TOKEN";
		$access_token = $this->_memcache->get($keyName);
		if ($access_token === false) {
			$access_token = $this->memcacheAccessToken();
		}
		
		$this->setLog("微信access_token:" . $access_token);
		$this->setLog("openid:$wxopenid");
		$this->setLog("模板ID:$wxtemplateid");
		$this->setLog("内容:$content");
		
		$this->send_wx($access_token, $wxopenid, $wxtemplateid, $content);
	}

	/**
	 * PTW72 GPRS MODEM 发短信
	 *
	 * @param string $number
	 *        	发送号码
	 * @param string $content
	 *        	内容
	 */
	public function smsEquipment_1($number, $content)
	{
		$arr = array(
			'type' => 'forward',
			'eq_type' => 'ptw72',
			'data' => array(
				'number' => $number,
				'content' => $content
			)
		);
		QMC::input('QMC-MSG', $arr);
	}

	/**
	 * OM-B4 综合报警器 发短信
	 *
	 * @param string $number
	 *        	发送号码
	 * @param string $content
	 *        	内容
	 */
	public function smsEquipment_2($number, $content)
	{
		// OM-B4 综合报警器 发短信
		$inter = "\r\n"; // 回车字符
		$ctrlz = chr(26); // ctrl+z
		
		$content = iconv("UTF-8", "GB2312//IGNORE", $content);
		
		$msf = 'send_sms("' . $number . '", "' . $content . '")' . $inter;
		
		// 写入队列
		$arr = array(
			'type' => 'forward',
			'eq_type' => 'omb4',
			'data' => $msf
		);
		QMC::input('QMC-MSG', $arr);
	}
	
	/**
	 * 一信通 发短信
	 *
	 * @param string $number
	 *        	发送号码
	 * @param string $content
	 *        	内容
	 */
	public function smsUMS($number, $content)
	{
		error_reporting(E_ALL ^ E_NOTICE ^ E_WARNING);
		
		$keyName = "PARAMETERS";
		$arrParameters = $this->_memcache->get($keyName);
		
		if ($arrParameters === false) {
			// 设置参数设置
			$arrParameters = $this->memcacheParameters();
		}
		
		$ums_SpCode = isset($arrParameters['ums_SpCode']) ? $arrParameters['ums_SpCode'] : '';
		$ums_LoginName = isset($arrParameters['ums_LoginName']) ? $arrParameters['ums_LoginName'] : '';
		$ums_Password = isset($arrParameters['ums_Password']) ? $arrParameters['ums_Password'] : '';
		
		// 一信通发送短信
		$url = "https://api.ums86.com:9600/sms/Api/Send.do";
		$arr = array(
			'SpCode' => $ums_SpCode,
			'LoginName' => $ums_LoginName,
			'Password' => $ums_Password,
			'MessageContent' => $content,
			'UserNumber' => $number,
			'SerialNumber' => time(),
			'ScheduleTime' => '',
			'f' => '1'
		);
		
		$result = $this->curl_request($url, $arr);
		$result = iconv("GB2312//IGNORE", "UTF-8", $result);
		
		$this->setLog('短信内容：' . $content);
		$this->setLog('一信通发送短信：' . $result);
	}
	
	/**
	 * 酒厂温控机 发短信
	 *
	 * @param string $number
	 *        	发送号码
	 * @param string $content
	 *        	内容
	 */
	public function smsJCWKJ($number, $content)
	{
		error_reporting(E_ALL ^ E_NOTICE ^ E_WARNING);
		
		$keyName = "PARAMETERS";
		$arrParameters = $this->_memcache->get($keyName);
		
		if ($arrParameters === false) {
			// 设置参数设置
			$arrParameters = $this->memcacheParameters();
		}
		
		$jcwkj_AppName = isset($arrParameters['jcwkj_AppName']) ? $arrParameters['jcwkj_AppName'] : '';
		$jcwkj_Key = isset($arrParameters['jcwkj_Key']) ? $arrParameters['jcwkj_Key'] : '';
		$time = time();
		
		// 酒厂温控机发送短信
		$str = $number . $content . $time;
		$str = urlencode($str);
		$encodeStr = md5($str);
		$encodeStr = $encodeStr . $jcwkj_Key;
		$token = sha1($encodeStr);
		
		$url = "https://fc.exijiu.cn/wx/public/index.php/api/smsapi/sendMsg";
		$arr = array(
			'appName' => $jcwkj_AppName,
			'mobile' => $number,
			'msg' => $content,
			'time' => $time,
			'token' => $token,
		);
		
		$result = $this->curl_request($url, $arr);
		
		$this->setLog('' . json_encode($arr, JSON_UNESCAPED_UNICODE));
		$this->setLog('短信内容：' . $content);
		$this->setLog('酒厂温控机发送短信：' . $result);
	}

	/**
	 * OM-B4 综合报警器 打电话
	 *
	 * @param string $number
	 *        	发送号码
	 * @param string $content
	 *        	内容
	 */
	public function tellEquipment_2($number, $content)
	{
		// OM-B4 综合报警器 打电话
		$inter = "\r\n"; // 回车字符
		$ctrlz = chr(26); // ctrl+z
		
		$content = iconv("UTF-8", "GB2312//IGNORE", $content);
		
		$msf = 'rf_call("' . $number . '", "' . $content . '")' . $inter;
		
		// 写入队列
		$arr = array(
			'type' => 'forward',
			'eq_type' => 'omb4',
			'data' => $msf
		);
		QMC::input('QMC-MSG', $arr);
	}

	/**
	 * 发邮件
	 *
	 * @param array $data
	 *        	数据数组
	 * @param string $AddAddress
	 *        	收件人地址
	 * @return string 内容
	 *        
	 */
	public function send_mail($AddAddress, $username, $password, $smtp, $port, $content)
	{
		$pattern = "/^([0-9A-Za-z\\-_\\.]+)@([0-9a-z]+\\.[a-z]{2,3}(\\.[a-z]{2})?)$/i";
		$domain_name = preg_replace($pattern, "$2", $username);
		$FromName = preg_replace($pattern, "$1", $username); // 发件人
		
		$Subject = "标题"; // 标题
		$Subject = "=?utf-8?B?" . base64_encode($Subject) . "?=";
		
		$body = $content;
		;
		$body = preg_replace('/\\\/', '', $body);
		
		$mail = new PHPMailer();
		
		// 设置smtp参数
		$mail->IsSMTP();
		$mail->SMTPAuth = true;
		$mail->SMTPKeepAlive = true;
		$mail->Host = $smtp;
		$mail->Port = $port;
		$mail->Charset = "UTF-8";
		// 填写你的gmail账号和密码
		$mail->Username = $username;
		$mail->Password = $password;
		
		// 设置发送方，最好不要伪造地址
		$mail->From = $username;
		$mail->FromName = $FromName;
		$mail->Subject = $Subject;
		$mail->AltBody = $body;
		$mail->WordWrap = 50; // 设置每行字符串的长度
		$mail->MsgHTML($body);
		
		// 设置回复地址
		$mail->AddReplyTo($username, $FromName);
		
		// 设置邮件接收方的邮箱和姓名
		$mail->AddAddress($AddAddress, $AddAddress);
		
		// 使用HTML格式发送邮件
		$mail->IsHTML(true);
		
		// 通过Send方法发送邮件
		$mail->Send();
	}

	/**
	 * 发送微信模板消息
	 *
	 * @param string $access_token
	 *        	微信access_token
	 * @param string $wxopenid
	 *        	用户openid
	 * @param string $wxtemplateid
	 *        	模板消息id
	 * @param string $content
	 *        	尼尔
	 */
	public function send_wx($access_token, $wxopenid, $wxtemplateid, $content)
	{
		$url = "https://api.weixin.qq.com/cgi-bin/message/template/send?access_token=$access_token";
		$data = array(
			'touser' => $wxopenid,
			'template_id' => $wxtemplateid,
			'data' => json_decode($content, true)
		);
		$data = json_encode($data, JSON_UNESCAPED_UNICODE);
		$output = $this->https_request($url, $data);
		$this->setLog("微信发送模板消息:" . $output);
	}

	public function utf82unicode($str)
	{
		return iconv("utf-8", "UCS-2BE//TRANSLIT//IGNORE", $str);
	}

	public function hex2str($hexstring)
	{
		$str = '';
		for ($i = 0, $len = strlen($hexstring); $i < $len; $i ++) {
			$str .= sprintf("%02X", ord(substr($hexstring, $i, 1)));
		}
		return $str;
	}

	public function invertNumbers($msisdn)
	{
		$len = strlen($msisdn);
		if (0 != fmod($len, 2)) {
			$msisdn .= "F";
			$len = $len + 1;
		}
		
		for ($i = 0; $i < $len; $i += 2) {
			$t = $msisdn[$i];
			$msisdn[$i] = $msisdn[$i + 1];
			$msisdn[$i + 1] = $t;
		}
		return $msisdn;
	}

	/**
	 * 内容处理
	 *
	 * @param string $tpl        	
	 * @return string
	 */
	public function contentProcessing($tpl, $arrAlertLogs)
	{
		$pubdate = $arrAlertLogs[0]['pubdate'];
		$eq_name = $arrAlertLogs[0]['eq_sn'] . '-' . $arrAlertLogs[0]['eq_no'];
		$alert_item = $arrAlertLogs[0]['alert_item'];
		$alert_value = $arrAlertLogs[0]['alert_value'];
		$alert_status = $arrAlertLogs[0]['alert_value'] == '1' ? '故障' : '告警';
		$relieve_type = $arrAlertLogs[0]['relieve_type'];
		
		// 获取设备信息
		$sql = "SELECT * FROM equipments WHERE `eq_sn`='" . $arrAlertLogs[0]['eq_sn'] . "' AND `eq_no`='" . $arrAlertLogs[0]['eq_no'] . "'";
		$arrEquipments = $this->db_getAll($sql);
		$eq_name = empty($arrEquipments) ? '' : $arrEquipments[0]['eq_name'];
		$arrMonitor = $this->getMonitor($arrEquipments[0]['properties']);
		foreach ($arrMonitor as $key => $value) {
			$arrTmp = explode(';', $arrAlertLogs[0]['alert_item']);
			foreach ($arrTmp as $l => $m) {
				if ($value['field_name'] == $m) {
					$alert_item = str_replace($value['field_name'], $value['name'], $alert_item);
					break;
				}
			}
		}
		
		// 自动解除告警
		if ($relieve_type == 2) {
			$alert_status = '';
			$relieve_type = "报警解除(" . date('Y-m-d H:i:s') . ")";
		} else {
			$relieve_type = '';
		}
		
		$tpl = str_replace('{$pubdate}', $pubdate, $tpl);
		$tpl = str_replace('{$eq_name}', $eq_name, $tpl);
		$tpl = str_replace('{$alert_item}', $alert_item, $tpl);
		$tpl = str_replace('{$alert_value}', $alert_value, $tpl);
		$tpl = str_replace('{$alert_status}', $alert_status, $tpl);
		$tpl = str_replace('{$relieve_type}', $relieve_type, $tpl);
		
		// 机房名称（包含层级关系）
		$name = '';
		if (strstr($tpl, '{$name}') !== false) {
			$sql = "SELECT * FROM groups WHERE `g_type`='1' AND `equips` LIKE '%\"ID\":\"" . $arrEquipments[0]['ID'] . "\"%'";
			$arrGroups = $this->db_getAll($sql);
			if (! empty($arrGroups)) {
				if (! empty($arrGroups[0]['parent_g'])) {
					$name = $this->getGroupsName($arrGroups[0]['parent_g']);
					$name .= $arrGroups[0]['name'];
				} else {
					$name = $arrGroups[0]['name'];
				}
			}
		}
		$tpl = str_replace('{$name}', $name, $tpl);
		
		return $tpl;
	}

	/**
	 * 递归获取机房名称（包含层级关系）
	 *
	 * @param int $gid
	 *        	分组ID
	 * @return string 机房名称
	 */
	public function getGroupsName($gid)
	{
		$name = '';
		
		$sql = "SELECT * FROM groups WHERE `g_type`='1' AND `ID`='$gid'";
		$arrGroups = $this->db_getAll($sql);
		if (! empty($arrGroups)) {
			if (! empty($arrGroups[0]['parent_g'])) {
				$name = $this->getGroupsName($arrGroups[0]['parent_g']);
				$name .= $arrGroups[0]['name'];
			} else {
				$name = $arrGroups[0]['name'];
			}
		}
		$name .= '->';
		
		return $name;
	}

	/**
	 * 记录日志
	 *
	 * @param string $str
	 *        	内容
	 * @param string $filename
	 *        	可选，文件名，默认'Forward_data'
	 */
	public function setLog($str, $filename = 'Forward_data')
	{
		$str .= PHP_EOL . PHP_EOL;
		file_put_contents("../logs/$filename" . "_" . date('Y-m-d') . ".log", $str, FILE_APPEND);
	}
}